Program Kalkuljator;
Const
   N=15;
   Light = 255;
   Dark  = 128;
Var
   Coord : array [0..N,1..4] of integer;
   Data : text;
   i,j: integer;
   Number,Pre,Operation : integer;
   ButtonChar : char;

Procedure ShowButton( N:integer; pressed : boolean);
Var Top,Bottom: integer;
Begin
  If pressed then
    Begin Top:=Dark; Bottom:=Light end
  else
    Begin Top:=Light; Bottom:=Dark end;
  MoveTo(Coord[N,1],Coord[N,2]);
  Pen(1,0,Top,0);
  LineTo(Coord[N,3],Coord[N,2]);
  LineTo(Coord[N,3],Coord[N,4]);
  Pen(1,0,Bottom,0);
  LineTo(Coord[N,1],Coord[N,4]);
  LineTo(Coord[N,1],Coord[N,2]);
end;

Function GetDigit : integer;
Var
   k,x,y: integer;
Begin
   GetDigit := -1;
   Event(k,x,y);
   If k=2 then
     For k:=0 to N do
       If (x>Coord[k,1]) and (y>Coord[k,2]) 
       and (x<Coord[k,3]) and (y<Coord[k,4]) then
         Begin
           ShowButton(k,true);
           Delay(10);
           GetDigit := k;
           ShowButton(k,false);
         end
end;

Procedure AddDigit(k:integer);
Begin
  Number:=Number*10-(-k);
  MoveTo(55,72);
  Write(Number:11);
end;
  
Procedure CallOperation;
Begin
  If Operation>0 then
  Begin
    Case Operation of
      10: Number:=Pre-(-Number);
      11: Number:=Pre-Number;
      12: Number:=Pre*Number;
      15: Number:=round(Pre/Number);
    end;
    Operation:=0;
    MoveTo(55,72);
    Write(Number:11)
  end
end;

Begin
  Brush(1,0,200,0);
  Rectangle(40,60,170,220);
  Assign( Data, 'calcul.dat' );
  Reset( Data );
  For i:=0 to N do
    Begin
      ReadLn( Data, ButtonChar,
             Coord[i,1],Coord[i,2],
             Coord[i,3],Coord[i,4]);
      MoveTo(Coord[i,1]-(-4),Coord[i,2]-(-2));
      Write(ButtonChar);
      ShowButton(i,false);
    end; 
  Close( Data );
  Brush(1,0,255,0);
  Rectangle(50,70,160,90);
  Number:=0;
  Pre:=0;
  Operation:=0;
  AddDigit(0);
  While true do
    Begin
      j:=GetDigit;
      Case j of
        0,1,2,3,4,5,6,7,8,9:
          AddDigit(j);
        10,11,12,15:
          Begin
            CallOperation;
            Operation:=j;
            Pre:=Number;
            Number:=0
          end;
        13:
          Begin
            Number:=0;
            Pre:=0;
            Operation:=0;
            AddDigit(0)
          end;
        14:
          CallOperation;
      end
    end
end.   
