Program BebelSortDemo; 
{Wizualizacja algorytmu sortowania bbelkowego}

{--------------------------------------}

Const n=140; 

Type Kolor=record 
             r,g,b: integer; 
           end; 
     Liczby=array[1..n] of integer; 
     Kolory=array[1..n] of Kolor; 
     
{--------------------------------------}     

Procedure Losuj(Var L: Liczby; Var K: Kolory); 

Var i: integer; 

Begin 
  For i:=1 to n do 
    Begin 
      L[i]:=1+random(350); 
      K[i].r:=random(255); 
      K[i].g:=random(255); 
      K[i].b:=random(255) 
    end 
end; {Losuj} 

{--------------------------------------}

Procedure Rysuj(i,x:integer; k:kolor); 

Begin 
  Pen(3,k.r,k.g,k.b); 
  MoveTo(0,3*i); 
  LineTo(x,3*i) 
end; {Rysuj}

{--------------------------------------}

Procedure Zamie(i,j: integer; Var L: Liczby; Var K: Kolory); 

Var pomx: integer; 
    pomk: Kolor; 

Begin 
  pomk.r:=255; pomk.g:=255; pomk.b:=255; 
  Rysuj(i,L[i],pomk); Rysuj(j,L[j],pomk); 
  pomx:=L[i]; L[i]:=L[j]; L[j]:=pomx; 
  pomk:=K[i]; K[i]:=K[j]; K[j]:=pomk; 
  Rysuj(i,L[i],K[i]); Rysuj(j,L[j],K[j])
end; {Zamie} 

{--------------------------------------}

Procedure BebelSort(Var L: Liczby; Var K: Kolory);

Var i,j,m,pom: integer;

Begin
  m:=n;
  While m>1 do
    Begin
      j:=1;
      For i:=1 to m-1 do
        If L[i]>L[i+1] then 
          Begin
            Zamie(i,i+1,L,K);
            j:=i
          end;
      m:=j
    end
end; {BbelSort}

{--------------------------------------}

Var L: Liczby; 
    K: Kolory; 
    i,j: integer; 

Begin   
  Randomize;
  Losuj(L,K); 
  For i:=1 to n do Rysuj(i,L[i],K[i]); 
  MoveTo(0,3*n); 
  WriteLn('Nacinij dowolny klawisz...'); 
  While not IsEvent do; 
  MoveTo(0,3*n); 
  WriteLn('                           '); 
  BebelSort(L,K) 
end.
