Program Labirynt3;

{----------------------------------------------------------}  

Const n=100; 

{----------------------------------------------------------}

Type TPole = record 
               w,k: integer 
             end; 
     TKolejka = array [0..n] of TPole; 
     
{----------------------------------------------------------}     

Var Kolejka: TKolejka; 
    Pocz,IleElem: integer; 
    
{----------------------------------------------------------}    

Procedure WstawDoKolejki(w,k: integer); 

Begin 
  If IleElem=n then WriteLn('BD! Przepeniona kolejka') 
  else Begin 
    Kolejka[(Pocz+IleElem) mod n].w:=w; 
    Kolejka[(Pocz+IleElem) mod n].k:=k; 
    IleElem:=IleElem+1 
  end 
end; {WstawDoKolejki} 

{----------------------------------------------------------}

Procedure UsuZKolejki(Var w,k: integer); 

Begin 
  If IleElem=0 then WriteLn('BD! Pusta kolejka') 
  else Begin 
    w:=Kolejka[Pocz].w; 
    k:=Kolejka[Pocz].k; 
    IleElem:=IleElem-1; 
    Pocz:=(Pocz+1) mod n 
  end 
end; {UsuZKolejki} 

{----------------------------------------------------------}

Function PustaKolejka: boolean; 

Begin 
  PustaKolejka:=(IleElem=0) 
end; {PustaKolejka} 

{----------------------------------------------------------}

Procedure InicjujKolejk; 

Begin 
  Pocz:=0; IleElem:=0 
end; {InicjujKolejk}

{==========================================================}

Type TLabirynt = array [0..14,0..19] of integer; 

{----------------------------------------------------------}

Var Labirynt: TLabirynt; 

{----------------------------------------------------------}

Procedure InicjujLabirynt; 

Var w,k: integer; 
    f: text; 
    ch: char; 
    
Begin 
  Assign(f,'Labirynt3.maz'); 
  Reset(f); 
  For w:=0 to 14 do 
    Begin 
      For k:=0 to 19 do 
        Begin 
          Read(f,ch); 
          If ch='w' then Labirynt[w,k]:=0 
          else Labirynt[w,k]:=1 
        end; 
      ReadLn(f) 
    end; 
  Close(f); 
  Labirynt[0,1]:=2 
end; {InicjujLabirynt} 

{----------------------------------------------------------}

Function SzukajDrog: boolean;

Var rw,rk,w,k,wart,kier: integer; 
    wyjscie: boolean; 
    
Begin 
  RobotCoord(rk,rw); 
  wyjscie:=false; 
  If Labirynt[1,1]<>0 then 
    Begin 
      Labirynt[1,1]:=3; 
      WstawDoKolejki(1,1) 
    end; 
  While not wyjscie and not PustaKolejka do 
    Begin 
      UsuZKolejki(w,k); 
      wart:=Labirynt[w,k]+1; 
      If (w=rw) and (k=rk) then wyjscie:=true 
      else Begin 
        If Labirynt[w-1,k]=1 then 
          Begin 
            Labirynt[w-1,k]:=Wart; 
            WstawDoKolejki(w-1,k) 
          end; 
        If Labirynt[w+1,k]=1 then 
          Begin 
            Labirynt[w+1,k]:=Wart; 
            WstawDoKolejki(w+1,k) 
          end; 
        If Labirynt[w,k-1]=1 then 
          Begin 
            Labirynt[w,k-1]:=Wart; 
            WstawDoKolejki(w,k-1) 
          end; 
        If Labirynt[w,k+1]=1 then 
          Begin 
            Labirynt[w,k+1]:=Wart; 
            WstawDoKolejki(w,k+1) 
          end 
      end 
    end; 
  SzukajDrog:=wyjscie
end; {SzukajDrog}

{----------------------------------------------------------}

Procedure ZaznaczDrog;

Var k,w,wart,kier: integer;

Begin
  RobotCoord(k,w);
  wart:=Labirynt[w,k]; 
  While wart>2 do 
    Begin 
      Select; 
      If Labirynt[w+1,k]=wart-1 then 
        Begin 
          w:=w+1; kier:=0 
        end 
      else If Labirynt[w-1,k]=wart-1 then 
        Begin 
          w:=w-1; kier:=2 
        end 
      else If Labirynt[w,k+1]=wart-1 then 
        Begin 
          k:=k+1; kier:=1 
        end 
      else 
        Begin 
          k:=k-1; kier:=3 
        end; 
      Case Direction-kier of 
        -3,1: RobotRight; 
        -1,3: RobotLeft; 
        -2,2: RobotLeft(2)
      end; 
      wart:=wart-1; 
      If wart>2 then RobotForw 
    end 
end; {ZaznaczDrog}

{==========================================================}

Begin 
  InicjujKolejk; 
  InicjujLabirynt; 
  If SzukajDrog then ZaznaczDrog 
  else Write('Nie ma wyjcia')
end.
