Program MiniPaint; 
Var 
   R,G,B,Width:integer; 
   k,x,y : integer; 

Procedure ShowMenu; 
Var 
   w : integer; 
Begin 
  Pen(1,0,0,0); 
  Brush(1,255,255,255); 
  Rectangle(0,0,256,60); 
  Pen(10,255,0,0); 
  Line(0,5,R,5); 
  Pen(10,0,255,0); 
  Line(0,15,G,15); 
  Pen(10,0,0,255); 
  Line(0,25,B,25);
  MoveTo(5,35);
  write('Color R=',R,' G=',G,' B=',B);
  Pen(1,0,0,0); 
  Brush(1,255,255,255); 
  Rectangle(256,0,600,60); 
  For w:=1 to 16 do 
    Begin 
      Pen(w,R,G,B); 
      Line((w-1)*20+256,15,w*20+256,15); 
    end; 
  MoveTo(260,35);
  write('Current line width = ',Width);
  Pen(Width,R,G,B) 
end; 

Procedure Menu(x,y:integer); 
Var 
   k : integer; 
Begin 
  If x<256 then 
    Begin 
      k := y div 10; 
      Case k of 
        0 : R:=x; 
        1 : G:=x; 
        2 : B:=x; 
      end 
    end 
  else 
    Width := (x-256) div 15 +1; 
  ShowMenu; 
end; 

Begin 
  R := 50; 
  G := 150; 
  B := 100;
  Width := 3; 
  Menu(60,50); 
  While true do 
    Begin 
      Event( k, x, y ); 
      Case k of 
        1 : Begin Clear; ShowMenu; end; 
        2 : If y<30 then Menu(x,y) else MoveTo(x,y); 
        3 : If y>60 then LineTo(x,y); 
      end 
    end 
end.
